--- /tmp/sshd	2011-09-07 09:41:23.000170625 +0200
+++ sshd	2011-09-07 10:20:27.691244769 +0200
@@ -5,12 +5,6 @@
 . /etc/conf.d/sshd
 
 PIDFILE=/var/run/sshd.pid
-PID=$(cat $PIDFILE 2>/dev/null)
-if ! readlink -q /proc/$PID/exe | grep -q '^/usr/sbin/sshd'; then
-  PID=
-  rm $PIDFILE 2>/dev/null
-fi
-
 case "$1" in
   start)
     stat_busy "Starting Secure Shell Daemon"
@@ -19,22 +13,20 @@
     [ -f /etc/ssh/ssh_host_dsa_key ] || { /usr/bin/ssh-keygen -t dsa -N "" -f /etc/ssh/ssh_host_dsa_key >/dev/null; }
     [ -f /etc/ssh/ssh_host_ecdsa_key ] || { /usr/bin/ssh-keygen -t ecdsa -N "" -f /etc/ssh/ssh_host_ecdsa_key >/dev/null; }
     [ -d /var/empty ] || mkdir -p /var/empty
-    [ -z "$PID" ] && /usr/sbin/sshd $SSHD_ARGS
-    if [ $? -gt 0 ]; then
-      stat_fail
-    else
+    if start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE --exec /usr/sbin/sshd -- $SSHD_ARGS; then
       add_daemon sshd
       stat_done
+    else
+      stat_fail
     fi
     ;;
   stop)
     stat_busy "Stopping Secure Shell Daemon"
-    [ ! -z "$PID" ]  && kill $PID &> /dev/null
-    if [ $? -gt 0 ]; then
-      stat_fail
-    else
+    if start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE --exec /usr/sbin/sshd -- $SSHD_ARGS; then
       rm_daemon sshd
       stat_done
+    else
+      stat_fail
     fi
     ;;
   restart)
